import Database from "../structures/Database";
export declare class QuerySelector<T> {
    #private;
    constructor(db: Database<T>);
    selectAll(): this;
    get where(): this;
    get query(): string;
    select(columns: string[]): this;
    select(column: string): this;
    select(...columns: string[]): this;
    select(...columns: string[][]): this;
    get from(): this;
    table(table: string): this;
    get and(): this;
    get not(): this;
    get or(): this;
    column(c: string): this;
    equals(value: string | number): this;
    greater(value: string | number): this;
    lesser(value: string | number): this;
    greaterEqual(value: string | number): this;
    lesserEqual(value: string | number): this;
    in(arr: (string | number)[]): this;
    starts(value: string): this;
    all<K = unknown>(): K[];
    get<K = unknown>(): K;
    ends(value: string): this;
    includes(value: string): this;
}
//# sourceMappingURL=QuerySelector.d.ts.map