"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _QuerySelector_instances, _a, _QuerySelector_db, _QuerySelector_query, _QuerySelector_add, _QuerySelector_create, _QuerySelector_condition;
Object.defineProperty(exports, "__esModule", { value: true });
exports.QuerySelector = void 0;
class QuerySelector {
    constructor(db) {
        _QuerySelector_instances.add(this);
        _QuerySelector_db.set(this, void 0);
        _QuerySelector_query.set(this, []);
        __classPrivateFieldSet(this, _QuerySelector_db, db, "f");
    }
    selectAll() {
        __classPrivateFieldGet(this, _QuerySelector_query, "f").push(`SELECT *`);
        return this;
    }
    get where() {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_add).call(this, 'WHERE');
    }
    get query() {
        return __classPrivateFieldGet(this, _QuerySelector_query, "f").join(" ");
    }
    select(...columns) {
        const all = [];
        for (const cl of columns) {
            all.push(...cl);
        }
        __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_add).call(this, `SELECT ${columns.join(" ")}`);
        return this;
    }
    get from() {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_add).call(this, 'FROM');
    }
    table(table) {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_add).call(this, table);
    }
    get and() {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_add).call(this, 'AND');
    }
    get not() {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_add).call(this, 'NOT');
    }
    get or() {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_add).call(this, 'OR');
    }
    column(c) {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_add).call(this, c);
    }
    equals(value) {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_condition).call(this, '=', value);
    }
    greater(value) {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_condition).call(this, '>', value);
    }
    lesser(value) {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_condition).call(this, '<', value);
    }
    greaterEqual(value) {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_condition).call(this, '>=', value);
    }
    lesserEqual(value) {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_condition).call(this, '<=', value);
    }
    in(arr) {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_add).call(this, 'IN', `(${arr.map(c => __classPrivateFieldGet(QuerySelector, _a, "m", _QuerySelector_create).call(QuerySelector, c)).join(", ")})`);
    }
    starts(value) {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_add).call(this, 'LIKE', `'%${__classPrivateFieldGet(QuerySelector, _a, "m", _QuerySelector_create).call(QuerySelector, value)}'`);
    }
    all() {
        var _b;
        return (_b = __classPrivateFieldGet(this, _QuerySelector_db, "f").db) === null || _b === void 0 ? void 0 : _b.prepare(__classPrivateFieldGet(this, _QuerySelector_query, "f").join(" ")).all();
    }
    get() {
        var _b;
        return (_b = __classPrivateFieldGet(this, _QuerySelector_db, "f").db) === null || _b === void 0 ? void 0 : _b.prepare(__classPrivateFieldGet(this, _QuerySelector_query, "f").join(" ")).get();
    }
    ends(value) {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_add).call(this, 'LIKE', `'${__classPrivateFieldGet(QuerySelector, _a, "m", _QuerySelector_create).call(QuerySelector, value)}%'`);
    }
    includes(value) {
        return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_add).call(this, 'LIKE', `'%${__classPrivateFieldGet(QuerySelector, _a, "m", _QuerySelector_create).call(QuerySelector, value)}%'`);
    }
}
exports.QuerySelector = QuerySelector;
_a = QuerySelector, _QuerySelector_db = new WeakMap(), _QuerySelector_query = new WeakMap(), _QuerySelector_instances = new WeakSet(), _QuerySelector_add = function _QuerySelector_add(...args) {
    __classPrivateFieldGet(this, _QuerySelector_query, "f").push(...args.map(c => c.toString()));
    return this;
}, _QuerySelector_create = function _QuerySelector_create(c) {
    return typeof c === 'string' ? `'${c.replace(/'/g, '')}'` : c.toString();
}, _QuerySelector_condition = function _QuerySelector_condition(cond, val) {
    return __classPrivateFieldGet(this, _QuerySelector_instances, "m", _QuerySelector_add).call(this, `${cond} ${__classPrivateFieldGet(QuerySelector, _a, "m", _QuerySelector_create).call(QuerySelector, val)}`);
};
//# sourceMappingURL=QuerySelector.js.map